function [d, Q, R] = decouple_trick(W, n, Q, R)
% use QR recursive method on W'
% [h,Qnew,Rnew]=decouple_trick(W,n,Qold,Rold)

[~, N, K] = size(W);
d = zeros(N, K);

if n == 1
    Q = zeros(N, N, K);
    R = zeros(N, N-1, K);
end
for k = 1:K
    if n == 1
        Wtilde = W(2:N, :, k);
        [Q(:, :, k), R(:, :, k)] = qr(Wtilde');
    else
        n_last = n - 1;
        e_last = zeros(N-1, 1);
        e_last(n_last) = 1;
        [Q(:, :, k), R(:, :, k)] = qrupdate(Q(:, :, k), R(:, :, k), -W(n, :, k)', e_last);
        [Q(:, :, k), R(:, :, k)] = qrupdate(Q(:, :, k), R(:, :, k), W(n_last, :, k)', e_last);
    end
    d(:, k) = Q(:, end, k); % d should be orthogonal to Wtilde
end

end